#ifndef directx10_H
#define directx10_H

#include "gpgpu02.h"

#pragma comment (lib,"d3d10.lib")
#pragma comment (lib,"d3dx10.lib")

class DX10gpgpu 
{
	ID3D10Device * pD3DDev; // Interface pointer to video card
	ID3D10Texture2D * pTexIn;
	ID3D10Texture2D * pTexRel;
	ID3D10EffectScalarVariable * pRVarPivot;
	ID3D10EffectScalarVariable * pRVarWidth;
	ID3D10EffectScalarVariable * pRVarHeight;
	ID3D10Effect * pEffect;
	ID3D10EffectTechnique *	pTechniqueSubMat;
	ID3D10EffectTechnique * pTechniqueRow;
	ID3D10EffectShaderResourceVariable * pSRVarTexIn;
	ID3D10EffectShaderResourceVariable * pSRVarTexTemp;
	HRESULT lastRet;

	int width, height;
	float* inMatrix;

public:
	DX10gpgpu();
	~DX10gpgpu();
	void InitDirect3D(HWND hWnd);
	void Render();
	void InputData( char * fileName );
	void ReloadData();
	void OutputData( char * fileName );
	void OutputData(ID3D10Texture2D * tex=NULL, int w=-1, int h=-1, char * fileName=NULL);
	void LogInfo();
};

#endif