#ifndef directx9_H
#define directx9_H

#include "gpgpu02.h"

#pragma comment (lib,"d3d9.lib")
#pragma comment (lib,"d3dx9.lib")

class DX9gpgpu 
{
public:
	LPDIRECT3D9 pD3D; // Interface pointer to of Direct3D
//	LPDIRECT3DVERTEXBUFFER9 pVB; // The interface pointer to vertex buffer for hold our main object.
	LPD3DXEFFECT pEffect;
//	LPDIRECT3DVERTEXDECLARATION9 pVertexDeclaration;
	LPDIRECT3DTEXTURE9 pInTex; // Texture object to hold IN texture image.
	LPDIRECT3DTEXTURE9 pTexRel; // For reload
	LPDIRECT3DTEXTURE9 pTempTex;
	LPDIRECT3DTEXTURE9 pPongTex;

	LPDIRECT3DSURFACE9 pInSurf;
	LPDIRECT3DSURFACE9 pTempSurf;
	LPDIRECT3DSURFACE9 pPongSurf;

	D3DCAPS9 D3DCaps; // Get the capabilities of the hardware.
	LPDIRECT3DDEVICE9 pD3DDev; // Interface pointer to video card

	int width, height;
	float* inMatrix;

public:
	DX9gpgpu();
	~DX9gpgpu();
	void InitDirect3D(HWND hWnd);
	void Render(int width, int height);
	void RenderTest(int width, int height);
	void RenderMulMat(int width, int height, int mul);
	void ClearTexture(LPDIRECT3DTEXTURE9 pClearTex,int width,int height);
	void InputData( char * fileName, bool int_test=false, double a=0, double b=0 );
	void ReloadData();
	void InputDataTest( char * fileName, double a, double b );
	void OutputDataTest();
	void OutputData( char * fileName, char * precision=NULL );
	void OutputData( LPDIRECT3DSURFACE9 src=NULL, int w=-1, int h=-1, bool first_int=false, char * fileName = NULL, char * precision=NULL );
	void LogInfo();
};

#endif