#ifndef gpgpu02_H
#define gpgpu02_H

//#define DEBUG_LOG // Log semi-results (slowest)
//#define LOG_WHOLE_TABLE // Result full matrix or last line only
//#define GENERATE_NON_RANDOM // If generate, then make solid result (1)
//#define DEBUG_DX // Debug flag to directx (slower)
#define INFO_LOG // Log information about graphics card and processor
#define LOG_TYPE "%.4f" // Default output precision
#define LOG_TYPE_PRECCOMP "%.20f" // For precision compare need longer output
//#define LOG_TYPE "%.20f"
#define INPUT_DIV 1 // jakym cislem vydelit vstup (na ozkouseni desetinych cisel)

// #include <windows.h>
#include <d3dx9.h>
#include <stdio.h>
#include <d3dx10.h>
#include <string>
#include <iostream>
#include <tchar.h>

#ifdef INFO_LOG
#include <DXGI.h>
#pragma comment (lib,"DXGI.lib")
#endif

#define MAXSTRSIZE 1024
extern TCHAR buf[MAXSTRSIZE+1];

#define WIN32_LEAN_AND_MEAN // Exclude the stuff we don't need in libraies. (speedup compilation)
#define VC_LEANMEAN // Exclude even further.

#define COMPILE_DX10

const int defaultComputeStyle=1|2|4|32|128; // bitmask 1 - CPU, 2 - DX9, 4 - DX10, 8 - FIRESTREAM, 16 - CUDA, 32 - COMPARE_PRECISION, 128 - CPU double precision
const int defaultGenerate=0; // 0 - read from file, othervise size of random generated matrix

//#define RELEASE(p) if (p) {int i=(p)->Release(); if ( i>0 ) Error(*"Release still counted %d.",false,i); (p)=NULL;} // memory multiplex open prevention macro with cassert when still used
#define RELEASE(p) if (p) {(p)->Release(); (p)=NULL;} // memory multiplex open prevention macro
#define FAILED_VALID(p) (!(p->IsValid())) // DX10 returning invalid pointers if failed

// prototype declaration
LRESULT CALLBACK WinProc (HWND, UINT, WPARAM, LPARAM);
void WindowCreate(HINSTANCE, HWND*);
void OutputTime(time_t, time_t, bool print_and_null=true );
void Error(const char &text, bool end=true,int code=0);
void Help(void);
void Close(void);
void OutputNote(const char &text);
void OutputNoteDefault(const char &text);
void OutputNoteInt(DWORD64);
void OutputNoteNL();
void GenerateRandomInput(int);
void Priority(short int i); //0=realtime; 1=high; 2=normal

typedef struct _CUVERTEX // vertex format for DX9
{
	float x, y, z, w;
	float u, v;
} CUVERTEX;

typedef struct _CUVERTEX3 // vertex format for DX10
{
	float x, y, z;
	float u, v;
} CUVERTEX3;

typedef struct _CUTEX // texture format
{ 
	float r, g, b, a;
} CUTEX;

#endif